﻿using Infragistics.Windows.DockManager;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace WPFContextMenu
{
    public class ViewModel : INotifyPropertyChanged
    {
        private bool _isNotFloating;
        public bool isNotFloating
        {
            get { return _isNotFloating; }
            set
            {
                if (_isNotFloating != value)
                {
                    _isNotFloating = value;
                    OnPropertyChanged("isNotFloating");
                }
            }
        }

        private bool _isWithinDocHost;
        public bool isWithinDocHost
        {
            get { return _isWithinDocHost; }
            set
            {
                if (_isWithinDocHost != value)
                {
                    _isWithinDocHost = value;
                    OnPropertyChanged("isWithinDocHost");
                }
            }
        }
        private bool _areMultipleItemsWithinTabGroup;
        public bool areMultipleItemsWithinTabGroup
        {
            get { return _areMultipleItemsWithinTabGroup; }
            set
            {
                if (_areMultipleItemsWithinTabGroup != value)
                {
                    _areMultipleItemsWithinTabGroup = value;
                    OnPropertyChanged("areMultipleItemsWithinTabGroup");
                }
            }
        }

        // add new >>
        private bool _isWithoutLastTabGroup;
        public bool isWithoutLastTabGroup
        {
            get { return _isWithoutLastTabGroup; }
            set
            {
                if (_isWithoutLastTabGroup != value)
                {
                    _isWithoutLastTabGroup = value;
                    OnPropertyChanged("isWithoutLastTabGroup");
                }
            }
        }
        private bool _isWithoutFirstTabGroup;
        public bool isWithoutFirstTabGroup
        {
            get { return _isWithoutFirstTabGroup; }
            set
            {
                if (_isWithoutFirstTabGroup != value)
                {
                    _isWithoutFirstTabGroup = value;
                    OnPropertyChanged("isWithoutFirstTabGroup");
                }
            }
        }
        // add new <<

        private ContentPane _curActivePane;

        public ContentPane curActivePane
        {
            get { return _curActivePane; }
            set
            {
                if (_curActivePane != value)
                {
                    _curActivePane = value;
                    OnPropertyChanged("curActivePane");
                }
            }
        }


        public ViewModel()
        {
            this.curActivePane = null;
            this.areMultipleItemsWithinTabGroup = false;
            this.isWithinDocHost = false;

            // add new >>
            this.isWithoutFirstTabGroup = false;
            this.isWithoutLastTabGroup = false;
            // add new <<
        }

        public ViewModel(bool isCloseButtonEnabled, ContentPane curActivePane)
        {
            this.curActivePane = curActivePane;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
